<nb-card *ngIf="moduleEditorService.onSelectedNodeChange() | async as selectedNode" [formGroup]="inputForm">
  <nb-card-header>
    <div class="title">({{ selectedNode.id }}) {{ selectedNode.name }}</div>
    <button
      nbButton
      class="TrashButton"
      status="danger"
      size="small"
      [disabled]="selectedNode === module.nodes.first"
      (click)="handleNodeRemove()"
    >
      <nb-icon icon="trash-alt"></nb-icon>
    </button>
  </nb-card-header>
  <nb-card-body>
    <div class="form-field dynamic-field">
      <textarea nbInput fullWidth formControlName="text"></textarea>
      <button nbButton ghost status="info" size="small" (click)="popoutText()">
        <nb-icon icon="expand"></nb-icon>
      </button>
    </div>

    <div class="form-field" *ngIf="isStartNode">
      <textarea nbInput fullWidth formControlName="description" placeholder="Description..."> </textarea>
    </div>

    <div class="form-field" *ngIf="!isStartNode && !isAnswerNode">
      <nb-select fullWidth multiple placeholder="Parent node" formControlName="parents">
        <nb-option *ngFor="let node of availableNodes" [value]="node.id"> ({{ node.id }}) {{ node.text }} </nb-option>
      </nb-select>
    </div>

    <div class="form-field" *ngIf="isImplicationNode">
      <nb-select fullWidth placeholder="Implication level" formControlName="implicationLevel">
        <nb-option value="highRisk">High risk</nb-option>
        <nb-option value="highPrioritySpecialist"> High priority (find specialist) </nb-option>
        <nb-option value="highPriorityYourself"> High priority (to do yourself) </nb-option>
        <nb-option value="backgroundInformation"> Background information </nb-option>
        <nb-option value="assumptions">Assumptions</nb-option>
      </nb-select>
    </div>

    <div class="form-field row" *ngIf="isQuestionNode">
      <button nbButton status="info" size="small" (click)="addExample()" class="question-button">
        Add new example
      </button>
      <div
        *ngFor="let example of examples.controls; let i = index"
        [formGroup]="example"
        class="dynamic-question-field"
      >
        <textarea nbInput fullWidth formControlName="text"> </textarea>
        <button nbButton ghost status="danger" size="small" (click)="removeExample(i)">
          <nb-icon icon="trash-alt"></nb-icon>
        </button>
      </div>

      <button nbButton status="info" size="small" (click)="addExplanation()" class="question-button">
        Add new explanation
      </button>
      <div
        *ngFor="let explanation of explanations.controls; let i = index"
        [formGroup]="explanation"
        class="dynamic-question-field"
      >
        <textarea nbInput fullWidth formControlName="text"> </textarea>
        <button nbButton ghost status="danger" size="small" (click)="removeExplanation(i)">
          <nb-icon icon="trash-alt"></nb-icon>
        </button>
      </div>

      <div class="question-toggles">
        <nb-toggle formControlName="multi">Multi</nb-toggle>
        <nb-toggle [disabled]="!inputForm.value.multi" formControlName="useUniqueRoutes"> Unique routes </nb-toggle>
      </div>
    </div>

    <div class="form-field row" *ngIf="isAnswerNode || isNotificationNode || isQuestionNode">
      <image-upload formControlName="image" [environment]="environment"></image-upload>
    </div>

    <div class="form-field" *ngIf="isEndNode">
      <nb-toggle formControlName="force"> Force </nb-toggle>
    </div>
  </nb-card-body>

  <nb-card-footer>
    <button nbButton status="success" [disabled]="inputForm.invalid || !inputForm.dirty" (click)="handleFormSubmit()">
      Save
    </button>
    <button
      nbButton
      [disabled]="isEndNode"
      [nbContextMenu]="isEndNode ? [{ title: 'none' }] : addNodeMenuItems[selectedNode.constructor.name]"
      nbContextMenuTag="module-actions-add"
    >
      Add node&nbsp;<nb-icon icon="caret-down"></nb-icon>
    </button>
  </nb-card-footer>
</nb-card>
